/*
 * PowerButton.c
 *
 * Created: 21.10.2015 11:45:30
 * Author : Patrick
 * Compiled with Atmel Studio 7.0
 */ 

#include <avr/io.h>
#include <util/delay.h>
#include <stdint.h>
#include <avr/interrupt.h>
#include <avr/wdt.h>

#define blink(delay) {	PORTB= (1<<PORTB2);	_delay_ms(delay);	PORTB&= ~(1<<PORTB2);	_delay_ms(delay);} // ON/OFF Button-LED blinks and the program proceeding is delayed by a 2x delay period

    /*
	"I/0"	=	"Name"			"Additional Information" 
	PA0		=	COVER_PWR_BTN
	PA1		=	Motor_OFF
	PA2		=	BAT1_ON_RIO
	PA3		=	TINY_BATTX_ON	-locks the power supply to an ON-state for HIGH
	PB0		=	CLK
	PB2		=	COVER_BTN_LED
	*/

uint8_t  n = 0; //Counter for MyRIO Off Signal

void ADC_Init(void){
	ADMUX &= ~( (1<<REFS0)|(1<<REFS0));
	ADCSRA = (1<<ADEN);
	ADCSRA |= (1<<ADSC);                  // eine ADC-Wandlung 
	while (ADCSRA & (1<<ADSC) ) {         // auf Abschluss der Konvertierung warten
	  }
	  /* ADCW muss einmal gelesen werden, sonst wird Ergebnis der nchsten
		 Wandlung nicht bernommen. */
	(void) ADCW;
}
uint16_t ADC_Read(void){
	ADMUX = (ADMUX & ~ (0x1F))|(ADC1D & 0x1F);
	ADCSRA |= (1<<ADSC);
	while(ADCSRA & (1<<ADSC)){		
	}
	return ADCW;
}
int main(void)
{	
	cli();
	DDRA &= ~( (1<<DDA0)|(1<<DDA2));
	DDRA |= (1<<DDA3);
	DDRB |= ((1<<PORTB1)|(1<<PORTB2));
	GIMSK|= (1<<PCIE0);
	PCMSK0|= (1<<PCINT2);
	WDTCSR|= (1<<WDIE)|(1<<WDP2);
	ADC_Init();
	uint8_t  i = 0;
	uint8_t  m = 0;
	uint16_t adc_val = 1023;
	//PORTA|= (1<<PORTA1); //H-Bridge OFF
	PORTB |= (1<<PORTB1);
	TIMSK1|= (1<<TOIE1); // Timer/Counter1, Overflow Interrupt Enable
	TCCR1B|= (1<<CS10); // Prescaler set to CLK/8
	sei();
	
    while (1) 
    {
		blink(400);
		blink(400);
		PORTA|= (1<<PORTA3); //ON-State locked
		PORTB|= ((1<<PORTB1)|(1<<PORTB2));
		while(PINA & (1 << PINA0)){}
		while(1){
			/*if(PINA & (1 << PINA2))
			{
				PORTA|= (1<<PORTA1);
			}
			else{
				PORTA&= ~(1<<PORTA1);
			}*/
								
			while(PINA & (1 << PINA0))
			{		
					if(i<=4){
					blink(125);
				    i++;
					}
					else{							
								PORTA&= ~(1<<PORTA3); //ON-State released
								PORTB&= ~(1<<PORTB2);
					}							
			}
			i=0;
			adc_val = ADC_Read();
				while(adc_val<626){
					if(m>4){
						PORTA&= ~(1<<PORTA3); //ON-State released
						PORTB&= ~(1<<PORTB2);
					}
				blink(100);
				adc_val = ADC_Read();
				m++;
				}
			}
			m=0;			
    }
	return(0);
}

ISR(PCINT0_vect){
wdt_reset();
if(n>=4){
	PORTA&= ~(1<<PORTA3); //ON-State released
	PORTB&= ~(1<<PORTB2);
	}	
PORTB&= ~(1<<PORTB1);
if(PINB & (1 << PINB2))
	{
	PORTB&= ~(1<<PORTB2);
	}
else{
	PORTB|= (1<<PORTB2);
	}
n++;
}
ISR(WDT_vect){
PORTB|= (1<<PORTB1);
wdt_reset();
PORTB|= (1<<PORTB2);
}

ISR(TIM1_OVF_vect){
	n=0;
}
